<html>
<head>
<title>OgreEdgeListBuilder.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreEdgeListBuilder.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreEdgeListBuilder_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __EdgeListBuilder_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __EdgeListBuilder_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector4_8h.html">OgreVector4.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareVertexBuffer_8h.html">OgreHardwareVertexBuffer.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderOperation_8h.html">OgreRenderOperation.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre {
<a name="l00051"></a><a class="code" href="classOgre_1_1EdgeData.html">00051</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1EdgeData.html" title="This class contains the information required to describe the edge connectivity of a given set of vert...">EdgeData</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">EdgeDataAlloc</a>
<a name="l00052"></a>00052     {
<a name="l00053"></a>00053     <span class="keyword">public</span>:
<a name="l00055"></a><a class="code" href="structOgre_1_1EdgeData_1_1Triangle.html">00055</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1EdgeData_1_1Triangle.html" title="Basic triangle structure.">Triangle</a> {
<a name="l00058"></a><a class="code" href="structOgre_1_1EdgeData_1_1Triangle.html#a77b9a1e73bea6c8cdbe3197a1311ad38">00058</a>             <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1EdgeData_1_1Triangle.html#a77b9a1e73bea6c8cdbe3197a1311ad38" title="The set of indexes this triangle came from (NB it is possible that the triangles on one side of an ed...">indexSet</a>; 
<a name="l00060"></a><a class="code" href="structOgre_1_1EdgeData_1_1Triangle.html#a8bf63fc09c7508d4c4863168442520db">00060</a>             <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1EdgeData_1_1Triangle.html#a8bf63fc09c7508d4c4863168442520db" title="The vertex set these vertices came from.">vertexSet</a>;
<a name="l00061"></a><a class="code" href="structOgre_1_1EdgeData_1_1Triangle.html#af3610ee6a688cccc061392263bde1929">00061</a>             <span class="keywordtype">size_t</span> vertIndex[3];
<a name="l00062"></a><a class="code" href="structOgre_1_1EdgeData_1_1Triangle.html#a7d4ef75a8c204871c1829dbae25e5f7d">00062</a>             <span class="keywordtype">size_t</span> sharedVertIndex[3]; 
<a name="l00063"></a>00063                                         <span class="comment">// duplicates eliminated (this buffer is not exposed)</span>
<a name="l00064"></a>00064 
<a name="l00065"></a><a class="code" href="structOgre_1_1EdgeData_1_1Triangle.html#ac676a82255cafa821af2f4143160f2b1">00065</a>             <a class="code" href="structOgre_1_1EdgeData_1_1Triangle.html#ac676a82255cafa821af2f4143160f2b1" title="Vertex indexes, relative to a shared vertex buffer with.">Triangle</a>() :indexSet(0), vertexSet(0) {}
<a name="l00066"></a>00066         };
<a name="l00068"></a><a class="code" href="structOgre_1_1EdgeData_1_1Edge.html">00068</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1EdgeData_1_1Edge.html" title="Edge data.">Edge</a> {
<a name="l00072"></a><a class="code" href="structOgre_1_1EdgeData_1_1Edge.html#ac5a9a9bc9dfc4d301058ee4e5c407f8f">00072</a>             <span class="keywordtype">size_t</span> triIndex[2];
<a name="l00075"></a><a class="code" href="structOgre_1_1EdgeData_1_1Edge.html#aad95e9ee5714e7413367fe6c8ba5dd20">00075</a>             <span class="keywordtype">size_t</span> vertIndex[2];
<a name="l00077"></a><a class="code" href="structOgre_1_1EdgeData_1_1Edge.html#a01c602e99ec1f7296cca73595e0ab55e">00077</a>             <span class="keywordtype">size_t</span> sharedVertIndex[2];
<a name="l00079"></a><a class="code" href="structOgre_1_1EdgeData_1_1Edge.html#a83b46b6487ee08a92449c8698fc8fc11">00079</a>             <span class="keywordtype">bool</span> <a class="code" href="structOgre_1_1EdgeData_1_1Edge.html#a83b46b6487ee08a92449c8698fc8fc11" title="Indicates if this is a degenerate edge, ie it does not have 2 triangles.">degenerate</a>;
<a name="l00080"></a>00080         };
<a name="l00081"></a>00081 
<a name="l00082"></a>00082         <span class="comment">// Array of 4D vector of triangle face normal, which is unit vector orthogonal</span>
<a name="l00083"></a>00083         <span class="comment">// to the triangles, plus distance from origin.</span>
<a name="l00084"></a>00084         <span class="comment">// Use aligned policy here because we are intended to use in SIMD optimised routines .</span>
<a name="l00085"></a><a class="code" href="classOgre_1_1EdgeData.html#a73d340f640bae10a852ce72c20d6fc80">00085</a>         <span class="keyword">typedef</span> std::vector&lt;Vector4, STLAllocator&lt;Vector4, CategorisedAlignAllocPolicy&lt;MEMCATEGORY_GEOMETRY&gt; &gt; &gt; <a class="code" href="classOgre_1_1EdgeData.html#a73d340f640bae10a852ce72c20d6fc80">TriangleFaceNormalList</a>;
<a name="l00086"></a>00086 
<a name="l00087"></a>00087         <span class="comment">// Working vector used when calculating the silhouette.</span>
<a name="l00088"></a>00088         <span class="comment">// Use std::vector&lt;char&gt; instead of std::vector&lt;bool&gt; which might implemented</span>
<a name="l00089"></a>00089         <span class="comment">// similar bit-fields causing loss performance.</span>
<a name="l00090"></a><a class="code" href="classOgre_1_1EdgeData.html#a04df16ab7fe244a33820dc2ed93bb2d5">00090</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;char&gt;::type</a> <a class="code" href="classOgre_1_1EdgeData.html#a04df16ab7fe244a33820dc2ed93bb2d5">TriangleLightFacingList</a>;
<a name="l00091"></a>00091 
<a name="l00092"></a><a class="code" href="classOgre_1_1EdgeData.html#abfe60759d5939159ecab6efb47c81190">00092</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;Triangle&gt;::type</a> <a class="code" href="classOgre_1_1EdgeData.html#abfe60759d5939159ecab6efb47c81190">TriangleList</a>;
<a name="l00093"></a><a class="code" href="classOgre_1_1EdgeData.html#aaa375d98aaa806ce481eb1fe38b4a3ce">00093</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;Edge&gt;::type</a> <a class="code" href="classOgre_1_1EdgeData.html#aaa375d98aaa806ce481eb1fe38b4a3ce">EdgeList</a>;
<a name="l00094"></a>00094 
<a name="l00096"></a><a class="code" href="structOgre_1_1EdgeData_1_1EdgeGroup.html">00096</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1EdgeData_1_1EdgeGroup.html" title="A group of edges sharing the same vertex data.">EdgeGroup</a>
<a name="l00097"></a>00097         {
<a name="l00099"></a><a class="code" href="structOgre_1_1EdgeData_1_1EdgeGroup.html#a86c3d3704b9370b9601be1b1ef21316f">00099</a>             <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1EdgeData_1_1EdgeGroup.html#a86c3d3704b9370b9601be1b1ef21316f" title="The vertex set index that contains the vertices for this edge group.">vertexSet</a>;
<a name="l00101"></a><a class="code" href="structOgre_1_1EdgeData_1_1EdgeGroup.html#a1564edb1edb8ee140fd14ee683cae134">00101</a>             <span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* <a class="code" href="structOgre_1_1EdgeData_1_1EdgeGroup.html#a1564edb1edb8ee140fd14ee683cae134" title="Pointer to vertex data used by this edge group.">vertexData</a>;
<a name="l00106"></a><a class="code" href="structOgre_1_1EdgeData_1_1EdgeGroup.html#ac1492097f952ad47429aed81471d1308">00106</a>             <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1EdgeData_1_1EdgeGroup.html#ac1492097f952ad47429aed81471d1308" title="Index to main triangles array, indicate the first triangle of this edge group, and all triangles of t...">triStart</a>;
<a name="l00108"></a><a class="code" href="structOgre_1_1EdgeData_1_1EdgeGroup.html#a41b7c17951a90ca2a2518b497749fccf">00108</a>             <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1EdgeData_1_1EdgeGroup.html#a41b7c17951a90ca2a2518b497749fccf" title="Number triangles of this edge group.">triCount</a>;
<a name="l00110"></a><a class="code" href="structOgre_1_1EdgeData_1_1EdgeGroup.html#ac1cefca66bbcb95e3a5b8967bbcd94f2">00110</a>             <a class="code" href="classOgre_1_1EdgeData.html#aaa375d98aaa806ce481eb1fe38b4a3ce">EdgeList</a> <a class="code" href="structOgre_1_1EdgeData_1_1EdgeGroup.html#ac1cefca66bbcb95e3a5b8967bbcd94f2" title="The edges themselves.">edges</a>;
<a name="l00111"></a>00111 
<a name="l00112"></a>00112         };
<a name="l00113"></a>00113 
<a name="l00114"></a><a class="code" href="classOgre_1_1EdgeData.html#a0976a49e32a6081b951b458df36c60b2">00114</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;EdgeGroup&gt;::type</a> <a class="code" href="classOgre_1_1EdgeData.html#a0976a49e32a6081b951b458df36c60b2">EdgeGroupList</a>;
<a name="l00115"></a>00115 
<a name="l00119"></a><a class="code" href="classOgre_1_1EdgeData.html#adcd3d9c03ce2bf3a8634b12fe78a9677">00119</a>         <a class="code" href="classOgre_1_1EdgeData.html#abfe60759d5939159ecab6efb47c81190">TriangleList</a> <a class="code" href="classOgre_1_1EdgeData.html#adcd3d9c03ce2bf3a8634b12fe78a9677" title="Main triangles array, stores all triangles of this edge list.">triangles</a>;
<a name="l00121"></a><a class="code" href="classOgre_1_1EdgeData.html#ad171b0cbf84c2266e90ccb093485ea9b">00121</a>         <a class="code" href="classOgre_1_1EdgeData.html#a73d340f640bae10a852ce72c20d6fc80">TriangleFaceNormalList</a> <a class="code" href="classOgre_1_1EdgeData.html#ad171b0cbf84c2266e90ccb093485ea9b" title="All triangle face normals.">triangleFaceNormals</a>;
<a name="l00123"></a><a class="code" href="classOgre_1_1EdgeData.html#a846bb6792590b4a3dc9c9f03845feef3">00123</a>         <a class="code" href="classOgre_1_1EdgeData.html#a04df16ab7fe244a33820dc2ed93bb2d5">TriangleLightFacingList</a> <a class="code" href="classOgre_1_1EdgeData.html#a846bb6792590b4a3dc9c9f03845feef3" title="Triangle light facing states.">triangleLightFacings</a>;
<a name="l00125"></a><a class="code" href="classOgre_1_1EdgeData.html#a87c571c8ebe68b3ca039a003ffbe07ad">00125</a>         <a class="code" href="classOgre_1_1EdgeData.html#a0976a49e32a6081b951b458df36c60b2">EdgeGroupList</a> <a class="code" href="classOgre_1_1EdgeData.html#a87c571c8ebe68b3ca039a003ffbe07ad" title="All edge groups of this edge list.">edgeGroups</a>;
<a name="l00127"></a><a class="code" href="classOgre_1_1EdgeData.html#a85e8278c626ea184a00081f199d14959">00127</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1EdgeData.html#a85e8278c626ea184a00081f199d14959" title="Flag indicate the mesh is manifold.">isClosed</a>;
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 
<a name="l00139"></a>00139         <span class="keywordtype">void</span> updateTriangleLightFacing(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; lightPos);
<a name="l00145"></a>00145         <span class="keywordtype">void</span> updateFaceNormals(<span class="keywordtype">size_t</span> vertexSet, <span class="keyword">const</span> <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>&amp; positionBuffer);
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00149"></a>00149         <span class="comment">// Debugging method</span>
<a name="l00150"></a>00150         <span class="keywordtype">void</span> log(<a class="code" href="classOgre_1_1Log.html">Log</a>* log);
<a name="l00151"></a>00151         
<a name="l00152"></a>00152     };
<a name="l00153"></a>00153 
<a name="l00163"></a><a class="code" href="classOgre_1_1EdgeListBuilder.html">00163</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1EdgeListBuilder.html" title="General utility class for building edge lists for geometry.">EdgeListBuilder</a> 
<a name="l00164"></a>00164     {
<a name="l00165"></a>00165     <span class="keyword">public</span>:
<a name="l00166"></a>00166 
<a name="l00167"></a>00167         <a class="code" href="classOgre_1_1EdgeListBuilder.html" title="General utility class for building edge lists for geometry.">EdgeListBuilder</a>();
<a name="l00168"></a>00168         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1EdgeListBuilder.html" title="General utility class for building edge lists for geometry.">EdgeListBuilder</a>();
<a name="l00174"></a>00174         <span class="keywordtype">void</span> addVertexData(<span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* vertexData);
<a name="l00185"></a>00185         <span class="keywordtype">void</span> addIndexData(<span class="keyword">const</span> <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>* indexData, <span class="keywordtype">size_t</span> vertexSet = 0, 
<a name="l00186"></a>00186             <a class="code" href="classOgre_1_1RenderOperation.html#a7a272218dae54048c87f31176c19e10d" title="The rendering operation type to perform.">RenderOperation::OperationType</a> opType = <a class="code" href="classOgre_1_1RenderOperation.html#a7a272218dae54048c87f31176c19e10da8c00ee152b44fe8000c2fd675437c087" title="A list of triangles, 3 vertices per triangle.">RenderOperation::OT_TRIANGLE_LIST</a>);
<a name="l00187"></a>00187 
<a name="l00192"></a>00192         <a class="code" href="classOgre_1_1EdgeData.html" title="This class contains the information required to describe the edge connectivity of a given set of vert...">EdgeData</a>* build(<span class="keywordtype">void</span>);
<a name="l00193"></a>00193 
<a name="l00195"></a>00195         <span class="keywordtype">void</span> log(<a class="code" href="classOgre_1_1Log.html">Log</a>* l);
<a name="l00196"></a>00196     <span class="keyword">protected</span>:
<a name="l00197"></a>00197 
<a name="l00203"></a><a class="code" href="structOgre_1_1EdgeListBuilder_1_1CommonVertex.html">00203</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1EdgeListBuilder_1_1CommonVertex.html" title="A vertex can actually represent several vertices in the final model, because vertices along texture s...">CommonVertex</a> {
<a name="l00204"></a><a class="code" href="structOgre_1_1EdgeListBuilder_1_1CommonVertex.html#a816fab86b7dcaf951ca4a0cb1bd14e48">00204</a>             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>  <a class="code" href="structOgre_1_1EdgeListBuilder_1_1CommonVertex.html#a816fab86b7dcaf951ca4a0cb1bd14e48">position</a>;  <span class="comment">// location of point in euclidean space</span>
<a name="l00205"></a><a class="code" href="structOgre_1_1EdgeListBuilder_1_1CommonVertex.html#a69ece006961f4ef9915a62f195fe69e1">00205</a>             <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1EdgeListBuilder_1_1CommonVertex.html#a69ece006961f4ef9915a62f195fe69e1">index</a>;       <span class="comment">// place of vertex in common vertex list</span>
<a name="l00206"></a><a class="code" href="structOgre_1_1EdgeListBuilder_1_1CommonVertex.html#a24eae6be08e186e0a89295375b168473">00206</a>             <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1EdgeListBuilder_1_1CommonVertex.html#a24eae6be08e186e0a89295375b168473">vertexSet</a>;   <span class="comment">// The vertex set this came from</span>
<a name="l00207"></a><a class="code" href="structOgre_1_1EdgeListBuilder_1_1CommonVertex.html#a05a377b1ca06547527392c89ac58972c">00207</a>             <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1EdgeListBuilder_1_1CommonVertex.html#a05a377b1ca06547527392c89ac58972c">indexSet</a>;    <span class="comment">// The index set this was referenced (first) from</span>
<a name="l00208"></a><a class="code" href="structOgre_1_1EdgeListBuilder_1_1CommonVertex.html#a69ecec711878bc47d7d7d7618e379dc8">00208</a>             <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1EdgeListBuilder_1_1CommonVertex.html#a69ecec711878bc47d7d7d7618e379dc8">originalIndex</a>; <span class="comment">// place of vertex in original vertex set</span>
<a name="l00209"></a>00209         };
<a name="l00211"></a><a class="code" href="structOgre_1_1EdgeListBuilder_1_1Geometry.html">00211</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1EdgeListBuilder_1_1Geometry.html" title="A set of indexed geometry data.">Geometry</a> {
<a name="l00212"></a><a class="code" href="structOgre_1_1EdgeListBuilder_1_1Geometry.html#a515e33f1461254ad3cdc7245b1376858">00212</a>             <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1EdgeListBuilder_1_1Geometry.html#a515e33f1461254ad3cdc7245b1376858">vertexSet</a>;           <span class="comment">// The vertex data set this geometry data refers to</span>
<a name="l00213"></a><a class="code" href="structOgre_1_1EdgeListBuilder_1_1Geometry.html#a75be34874367518d28ca0b75bfc59b85">00213</a>             <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1EdgeListBuilder_1_1Geometry.html#a75be34874367518d28ca0b75bfc59b85">indexSet</a>;            <span class="comment">// The index data set this geometry data refers to</span>
<a name="l00214"></a><a class="code" href="structOgre_1_1EdgeListBuilder_1_1Geometry.html#a39ec43d8e228bc697e446ae290123c5d">00214</a>             <span class="keyword">const</span> <a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>* <a class="code" href="structOgre_1_1EdgeListBuilder_1_1Geometry.html#a39ec43d8e228bc697e446ae290123c5d">indexData</a>; <span class="comment">// The index information which describes the triangles.</span>
<a name="l00215"></a><a class="code" href="structOgre_1_1EdgeListBuilder_1_1Geometry.html#a4a9b3308bf20885d61f2795b0b897903">00215</a>             <a class="code" href="classOgre_1_1RenderOperation.html#a7a272218dae54048c87f31176c19e10d" title="The rendering operation type to perform.">RenderOperation::OperationType</a> <a class="code" href="structOgre_1_1EdgeListBuilder_1_1Geometry.html#a4a9b3308bf20885d61f2795b0b897903">opType</a>;  <span class="comment">// The operation type used to render this geometry</span>
<a name="l00216"></a>00216         };
<a name="l00218"></a><a class="code" href="structOgre_1_1EdgeListBuilder_1_1geometryLess.html">00218</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1EdgeListBuilder_1_1geometryLess.html" title="Comparator for sorting geometries by vertex set.">geometryLess</a> {
<a name="l00219"></a><a class="code" href="structOgre_1_1EdgeListBuilder_1_1geometryLess.html#ae3ee571d8bbc79683d4197d80330beb9">00219</a>             <span class="keywordtype">bool</span> operator()(<span class="keyword">const</span> <a class="code" href="structOgre_1_1EdgeListBuilder_1_1Geometry.html" title="A set of indexed geometry data.">Geometry</a>&amp; a, <span class="keyword">const</span> <a class="code" href="structOgre_1_1EdgeListBuilder_1_1Geometry.html" title="A set of indexed geometry data.">Geometry</a>&amp; b)<span class="keyword"> const</span>
<a name="l00220"></a>00220 <span class="keyword">            </span>{
<a name="l00221"></a>00221                 <span class="keywordflow">if</span> (a.<a class="code" href="structOgre_1_1EdgeListBuilder_1_1Geometry.html#a515e33f1461254ad3cdc7245b1376858">vertexSet</a> &lt; b.<a class="code" href="structOgre_1_1EdgeListBuilder_1_1Geometry.html#a515e33f1461254ad3cdc7245b1376858">vertexSet</a>) <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00222"></a>00222                 <span class="keywordflow">if</span> (a.<a class="code" href="structOgre_1_1EdgeListBuilder_1_1Geometry.html#a515e33f1461254ad3cdc7245b1376858">vertexSet</a> &gt; b.<a class="code" href="structOgre_1_1EdgeListBuilder_1_1Geometry.html#a515e33f1461254ad3cdc7245b1376858">vertexSet</a>) <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00223"></a>00223                 <span class="keywordflow">return</span> a.<a class="code" href="structOgre_1_1EdgeListBuilder_1_1Geometry.html#a75be34874367518d28ca0b75bfc59b85">indexSet</a> &lt; b.<a class="code" href="structOgre_1_1EdgeListBuilder_1_1Geometry.html#a75be34874367518d28ca0b75bfc59b85">indexSet</a>;
<a name="l00224"></a>00224             }
<a name="l00225"></a>00225         };
<a name="l00227"></a><a class="code" href="structOgre_1_1EdgeListBuilder_1_1vectorLess.html">00227</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1EdgeListBuilder_1_1vectorLess.html" title="Comparator for unique vertex list.">vectorLess</a> {
<a name="l00228"></a><a class="code" href="structOgre_1_1EdgeListBuilder_1_1vectorLess.html#a909bd54fed1252502a81e0cd7dfe5875">00228</a>             <span class="keywordtype">bool</span> operator()(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; a, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; b)<span class="keyword"> const</span>
<a name="l00229"></a>00229 <span class="keyword">            </span>{
<a name="l00230"></a>00230                 <span class="keywordflow">if</span> (a.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> &lt; b.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a>) <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00231"></a>00231                 <span class="keywordflow">if</span> (a.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a> &gt; b.<a class="code" href="classOgre_1_1Vector3.html#a27be092ad0b7e0504ddf4db5cd565f14">x</a>) <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00232"></a>00232                 <span class="keywordflow">if</span> (a.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> &lt; b.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a>) <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00233"></a>00233                 <span class="keywordflow">if</span> (a.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a> &gt; b.<a class="code" href="classOgre_1_1Vector3.html#a05ca4492ce30a049ae4102e3f5e85aff">y</a>) <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00234"></a>00234                 <span class="keywordflow">return</span> a.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a> &lt; b.<a class="code" href="classOgre_1_1Vector3.html#ab1f9e7702256f32156be4d7e0fdafd7e">z</a>;
<a name="l00235"></a>00235             }
<a name="l00236"></a>00236         };
<a name="l00237"></a>00237 
<a name="l00238"></a><a class="code" href="classOgre_1_1EdgeListBuilder.html#a1cf79a018c3d394a681a705968b8cb29">00238</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;const VertexData*&gt;::type</a> <a class="code" href="classOgre_1_1EdgeListBuilder.html#a1cf79a018c3d394a681a705968b8cb29">VertexDataList</a>;
<a name="l00239"></a><a class="code" href="classOgre_1_1EdgeListBuilder.html#a9d13398484a0dc3db6cdf5d026e22610">00239</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;Geometry&gt;::type</a> <a class="code" href="classOgre_1_1EdgeListBuilder.html#a9d13398484a0dc3db6cdf5d026e22610">GeometryList</a>;
<a name="l00240"></a><a class="code" href="classOgre_1_1EdgeListBuilder.html#a403ee411b89442d5561c15e2798344b2">00240</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;CommonVertex&gt;::type</a> <a class="code" href="classOgre_1_1EdgeListBuilder.html#a403ee411b89442d5561c15e2798344b2">CommonVertexList</a>;
<a name="l00241"></a>00241 
<a name="l00242"></a><a class="code" href="classOgre_1_1EdgeListBuilder.html#a5d4989a248aa1f8fc2f42d278aa708f0">00242</a>         <a class="code" href="classOgre_1_1EdgeListBuilder.html#a9d13398484a0dc3db6cdf5d026e22610">GeometryList</a> <a class="code" href="classOgre_1_1EdgeListBuilder.html#a5d4989a248aa1f8fc2f42d278aa708f0">mGeometryList</a>;
<a name="l00243"></a><a class="code" href="classOgre_1_1EdgeListBuilder.html#ac706c9ac2d689aa08556ba824386c97a">00243</a>         <a class="code" href="classOgre_1_1EdgeListBuilder.html#a1cf79a018c3d394a681a705968b8cb29">VertexDataList</a> <a class="code" href="classOgre_1_1EdgeListBuilder.html#ac706c9ac2d689aa08556ba824386c97a">mVertexDataList</a>;
<a name="l00244"></a><a class="code" href="classOgre_1_1EdgeListBuilder.html#a2b2c21a40cd9ce67461bd0164fe67a35">00244</a>         <a class="code" href="classOgre_1_1EdgeListBuilder.html#a403ee411b89442d5561c15e2798344b2">CommonVertexList</a> <a class="code" href="classOgre_1_1EdgeListBuilder.html#a2b2c21a40cd9ce67461bd0164fe67a35">mVertices</a>;
<a name="l00245"></a><a class="code" href="classOgre_1_1EdgeListBuilder.html#a8cc80f94959971521a82cc930cac46e9">00245</a>         <a class="code" href="classOgre_1_1EdgeData.html" title="This class contains the information required to describe the edge connectivity of a given set of vert...">EdgeData</a>* <a class="code" href="classOgre_1_1EdgeListBuilder.html#a8cc80f94959971521a82cc930cac46e9">mEdgeData</a>;
<a name="l00247"></a><a class="code" href="classOgre_1_1EdgeListBuilder.html#aab99422a5b615f1a8babca94ce3139a8">00247</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;Vector3, size_t, vectorLess&gt;::type</a> <a class="code" href="classOgre_1_1EdgeListBuilder.html#aab99422a5b615f1a8babca94ce3139a8" title="Map for identifying common vertices.">CommonVertexMap</a>;
<a name="l00248"></a><a class="code" href="classOgre_1_1EdgeListBuilder.html#a43c5862bbe8afebf7ca473fbcbf219e0">00248</a>         <a class="code" href="classOgre_1_1EdgeListBuilder.html#aab99422a5b615f1a8babca94ce3139a8" title="Map for identifying common vertices.">CommonVertexMap</a> <a class="code" href="classOgre_1_1EdgeListBuilder.html#a43c5862bbe8afebf7ca473fbcbf219e0">mCommonVertexMap</a>;
<a name="l00252"></a><a class="code" href="classOgre_1_1EdgeListBuilder.html#a8a45099b2356182b6e42e9659ea2acac">00252</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1multimap.html">multimap&lt; std::pair&lt;size_t, size_t&gt;</a>, std::pair&lt;size_t, size_t&gt; &gt;::type <a class="code" href="classOgre_1_1EdgeListBuilder.html#a8a45099b2356182b6e42e9659ea2acac" title="Edge map, used to connect edges.">EdgeMap</a>;
<a name="l00253"></a><a class="code" href="classOgre_1_1EdgeListBuilder.html#a49964dbb7e73349bed694df63ec9b372">00253</a>         <a class="code" href="classOgre_1_1EdgeListBuilder.html#a8a45099b2356182b6e42e9659ea2acac" title="Edge map, used to connect edges.">EdgeMap</a> <a class="code" href="classOgre_1_1EdgeListBuilder.html#a49964dbb7e73349bed694df63ec9b372">mEdgeMap</a>;
<a name="l00254"></a>00254 
<a name="l00255"></a>00255         <span class="keywordtype">void</span> buildTrianglesEdges(<span class="keyword">const</span> <a class="code" href="structOgre_1_1EdgeListBuilder_1_1Geometry.html" title="A set of indexed geometry data.">Geometry</a> &amp;geometry);
<a name="l00256"></a>00256 
<a name="l00258"></a>00258         <span class="keywordtype">size_t</span> findOrCreateCommonVertex(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vec, <span class="keywordtype">size_t</span> vertexSet, 
<a name="l00259"></a>00259             <span class="keywordtype">size_t</span> indexSet, <span class="keywordtype">size_t</span> originalIndex);
<a name="l00261"></a>00261         <span class="keywordtype">void</span> connectOrCreateEdge(<span class="keywordtype">size_t</span> vertexSet, <span class="keywordtype">size_t</span> triangleIndex, <span class="keywordtype">size_t</span> vertIndex0, <span class="keywordtype">size_t</span> vertIndex1, 
<a name="l00262"></a>00262             <span class="keywordtype">size_t</span> sharedVertIndex0, <span class="keywordtype">size_t</span> sharedVertIndex1);
<a name="l00263"></a>00263     };
<a name="l00267"></a>00267 }
<a name="l00268"></a>00268 <span class="preprocessor">#endif</span>
<a name="l00269"></a>00269 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
